%define _x11man1dir	%_x11mandir/man1
%define _pixmapsdir	%_datadir/pixmaps

%define drvs	modules/drivers
%define dris	modules/dri
%define lnxs	modules/linux

Name: fglrx_glx
Version: 3.7.0
Release: alt1
Summary: ATI drivers for Radeon and Fire GL
Group: System/Kernel and hardware

URL: http://www.ati.com/
License: Proprietary

Provides: libGL

Source0: http://www2.ati.com/drivers/linux/fglrx-glc22-4.3.0-%version.i386.rpm
Source1: http://www2.ati.com/drivers/linux/readme0370.txt

Source10: fireglcontrol.menu

Patch0: fglrx-3.7.0-panel.patch
Patch1: fglrx-3.7.0-tools-make.patch

Requires: XFree86-server >= 4.3.0

# Automatically added by buildreq on Sun Jan 04 2004
BuildRequires: XFree86-devel XFree86-libs chrpath cpio fontconfig freetype2 gcc-c++ libqt3-devel libstdc++-devel xpm-devel

BuildPreReq: kernel-build-tools

%description 
Proprietary ATI drivers for Radeon and Fire GL cards.

%package -n fglrx-tools
Summary: Utilities for ATI Radeon and Fire GL drivers
Group: System/Configuration/Hardware
Requires: %name = %version-%release

# Temporarily removed from the %%description below (fglrx_gamma is not packaged
# because libfglrx_gamma.so.1 is broken):
#
# fglrx_gamma is a small tool to adjust gamma.
#
%description -n fglrx-tools
ATI FireGL/Radeon configuration utilities:

fireglcontrol is [intended to be] a full-blown ATI graphics card
configuration panel similar to those in Microsoft(R) Windows(TM).

fglrxinfo is an analogue for glxinfo.

fglrxconfig is a replacement for xf86config. NOTE: USE WITH CAUTION!!!
This tool will erase your current XF86Config without making a backup
copy!

%package -n kernel-source-fglrx-%version
Summary: Linux fglrx (Radeon/Fire GL video card driver) module sources
Group: Development/Kernel

%description -n kernel-source-fglrx-%version
fglrx (Radeon/Fire GL video card driver) module sources for Linux kernel.

%prep
%setup -T -c
rpm2cpio %SOURCE0 | %__cpio -idmv --no-absolute-filenames --no-preserve-owner
%__install -p -m644 %SOURCE1 ./
%setup -D -T

pushd lib/modules/fglrx/build_mod
%__rm -f make.sh
cd ..
%__mv build_mod kernel-source-fglrx-%version
%__tar -cj -f ../../../kernel-source-fglrx-%version.tar.bz2 \
	kernel-source-fglrx-%version
popd

%__mkdir fglrx_panel
pushd fglrx_panel
%__tar -xz -f ../usr/src/ATI/fglrx_panel_sources.tgz
%patch0 -p1
popd

%__mkdir fglrx_tools
pushd fglrx_tools
%__tar -xz -f ../usr/src/ATI/fglrx_sample_source.tgz
%patch1 -p1
popd

%setup -D -T

# remove precompiled fglrxcontrol binaries
%__rm -f usr/X11R6/bin/*.bz2

%build
# Clean up the rpath mess
chrpath -d usr/X11R6/bin/*
find . -name '*.so*' -print0 | xargs -r0 chrpath -d --

pushd fglrx_panel
%make QTDIR=/usr/lib/qt3 \
	LIBS="-L/usr/lib/qt3/lib -lqt -L/usr/X11R6/lib -lXxf86vm"
popd

pushd fglrx_tools/programs/fglrx_gamma
xmkmf
%make
popd



%install
%set_strip_method executable
%set_verify_elf_method textrel=relaxed

%__mkdir_p %buildroot%_x11bindir
%__mkdir_p %buildroot%_x11libdir/%drvs
%__mkdir_p %buildroot%_x11libdir/%dris
%__mkdir_p %buildroot%_x11libdir/%lnxs
%__mkdir_p %buildroot%_x11includedir/X11/extensions
%__mkdir_p %buildroot%_x11man1dir
%__mkdir_p %buildroot%_menudir
%__mkdir_p %buildroot%_iconsdir
%__mkdir_p %buildroot%_pixmapsdir

%__mkdir_p %kernel_srcdir

%__install -p -m644 usr/X11R6/lib/%drvs/fglrx_drv.o \
	%buildroot%_x11libdir/%drvs/
%__install -p -m644 usr/X11R6/lib/%dris/fglrx_dri.so \
	%buildroot%_x11libdir/%dris/
%__install -p -m644 usr/X11R6/lib/%lnxs/libfglrxdrm.a \
	%buildroot%_x11libdir/%lnxs/

%__install -p -m644 usr/X11R6/lib/libGL.so.1.2 \
	%buildroot%_x11libdir/libGL.so.fglrx
#%__install -p -m644 usr/X11R6/lib/*gamma* %buildroot%_x11libdir/
#%__install -p -m644 usr/X11R6/include/X11/extensions/fglrx_gamma.h \
#	%buildroot%_x11includedir/X11/extensions/

%__install -p usr/X11R6/bin/fgl_glxgears	%buildroot%_x11bindir/
%__install -p usr/X11R6/bin/fglrxconfig		%buildroot%_x11bindir/
%__install -p usr/X11R6/bin/fglrxinfo		%buildroot%_x11bindir/
%__install -p fglrx_panel/fireglcontrol		%buildroot%_x11bindir/
#%__install -p fglrx_tools/programs/fglrx_gamma/fglrx_xgamma \
#	%buildroot%_x11bindir/
#%__install -p -m644 fglrx_tools/programs/fglrx_gamma/fglrx_xgamma.man \
#	%buildroot%_x11man1dir/fglrx_xgamma.1
%__install -p -m644 usr/share/icons/ati.xpm %buildroot%_iconsdir/
%__install -p -m644 usr/share/pixmaps/ati.xpm %buildroot%_pixmapsdir/
%__install -p -m644 %SOURCE10 %buildroot%_menudir/fireglcontrol

%__install -p -m644 kernel-source-fglrx-%version.tar.bz2 %kernel_srcdir/


%post
%post_ldconfig

%postun
%postun_ldconfig

%post -n fglrx-tools
%update_menus

%postun -n fglrx-tools
%clean_menus

%files
%_x11libdir/%drvs/*
%_x11libdir/%lnxs/*
%_x11libdir/%dris/*
%_x11libdir/libGL.so.fglrx
#%_x11libdir/*gamma*
#%attr(0644,root,root) %_x11includedir/X11/extensions/*
%doc readme0370.txt

%files -n fglrx-tools
%_x11bindir/*
%_iconsdir/*
%_pixmapsdir/*
%_menudir/*
#%_x11man1dir/*

%files -n kernel-source-fglrx-%version
%_usrsrc/*

%changelog
* Sat Jan 03 2004 Sergey Vlasov <vsu@altlinux.ru> 3.7.0-alt1
- Version 3.7.0.
- Use the RPM from ATI as Source instead of a repacked tarball.
- Fixed file modes.
- Relaxed TEXTREL check.
- Merged with Alexey Morozov <morozov@altlinux> changes:
  - build both fglrx_glx and kernel-source-fglrx packages from the single
    official ATI driver rpm package
  - new driver version (3.7.0)
  - fglrx_panel and fglrx_gamma is built and packaged into
    fglrx-tools subpackage
- Excluded *fglrx_gamma* because of wrong soname in libfglrx_gamma.so.1.
- Added README file from the ATI site (not included in the original RPM).
- Updated BuildRequires.

* Sun Oct 12 2003 Sergey Vlasov <vsu@altlinux.ru> 3.2.8-alt1
- new version (3.2.8)

* Tue Sep 09 2003 Rider <rider@altlinux.ru> 3.2.5-alt1
- new version

* Wed Jul 16 2003 Peter Novodvorsky <nidd@altlinux.com> 2.9.12-alt1
- initial release.

